package com.gxwebsoft.cms.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.cms.service.CmsDocsContentService;
import com.gxwebsoft.cms.entity.CmsDocsContent;
import com.gxwebsoft.cms.param.CmsDocsContentParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 文档内容记录表控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 20:47:57
 */
@Api(tags = "文档内容记录表管理")
@RestController
@RequestMapping("/api/cms/cms-docs-content")
public class CmsDocsContentController extends BaseController {
    @Resource
    private CmsDocsContentService cmsDocsContentService;

    @ApiOperation("分页查询文档内容记录表")
    @GetMapping("/page")
    public ApiResult<PageResult<CmsDocsContent>> page(CmsDocsContentParam param) {
        // 使用关联查询
        return success(cmsDocsContentService.pageRel(param));
    }

    @ApiOperation("查询全部文档内容记录表")
    @GetMapping()
    public ApiResult<List<CmsDocsContent>> list(CmsDocsContentParam param) {
        PageParam<CmsDocsContent, CmsDocsContentParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(cmsDocsContentService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(cmsDocsContentService.listRel(param));
    }

    @PreAuthorize("hasAuthority('cms:cmsDocsContent:list')")
    @OperationLog
    @ApiOperation("根据id查询文档内容记录表")
    @GetMapping("/{id}")
    public ApiResult<CmsDocsContent> get(@PathVariable("id") Integer id) {
        return success(cmsDocsContentService.getById(id));
        // 使用关联查询
        //return success(cmsDocsContentService.getByIdRel(id));
    }

    @ApiOperation("添加文档内容记录表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody CmsDocsContent cmsDocsContent) {
        if (cmsDocsContentService.save(cmsDocsContent)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改文档内容记录表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody CmsDocsContent cmsDocsContent) {
        if (cmsDocsContentService.updateById(cmsDocsContent)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除文档内容记录表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (cmsDocsContentService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加文档内容记录表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<CmsDocsContent> list) {
        if (cmsDocsContentService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改文档内容记录表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<CmsDocsContent> batchParam) {
        if (batchParam.update(cmsDocsContentService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除文档内容记录表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (cmsDocsContentService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
